-- These functions make the ripple cards much shorter, and allow me to make slight fixes if needed

Ripple_ResolutionTimeAction1 = function(ripple_count)
-- use this as the first RESOLUTION_TIME_ACTION of the ripple mechanic
	local player = EffectController()
	if player:IsAI() == 0 then
		player:SetCustomQueryInstructionValue( ripple_count )
		player:BeginNewMultipleChoice()
		player:AddMultipleChoiceAnswer( "CARD_QUERY_OPTION_YES" )
		player:AddMultipleChoiceAnswer( "CARD_QUERY_OPTION_NO" )
		player:AskMultipleChoiceQuestion( "CARD_QUERY_MC_RIPPLE" )
	end
end

Ripple_ResolutionTimeAction2 = function(ripple_count)
-- use this as the second RESOLUTION_TIME_ACTION of the ripple mechanic
	local player = EffectController()
	local decision = Object():GetMultipleChoiceResult()
	if player:IsAI() ~= 0 or decision == 0 then

		local library_count = player:Library_Count()
		if library_count == 0 then
			return
		end

		local to_reveal = ripple_count
		if library_count < ripple_count then
			to_reveal = library_count
		end

		local reveal_chest = EffectDC():Make_Chest(1)
		for i=0,to_reveal-1 do
			local card = player:Library_GetNth(i)
			if card ~= nil then
				reveal_chest:Set_CardPtr(i, card)
			end
		end

		local filter = Object():GetFilter()
		filter:Clear()
		filter:NotTargetted()
		filter:SetPlayer( player )
		filter:SetZone( ZONE_LIBRARY )
		filter:SetPortion( to_reveal )
		filter:AddCardName( TriggerObject():GetCardName() )
		local playable = filter:Count()
		if playable > 0 then
			player:SetTargetCount( playable )
			for i=0,playable-1 do
				player:SetTargetPrompt( i, "CARD_QUERY_PLAY_OR_BOTTOM_LIBRARY" )
			end
			player:ChooseTargetsWithFlags( NO_VALIDATION, EffectDC():Make_Targets(0),
				QUERY_FLAG_CAN_BE_FINISHED_EARLY + QUERY_FLAG_CAN_BE_FINISHED_EARLY_FOR_AI_AS_WELL )
		end
	end
end

Ripple_ResolutionTimeAction3 = function(ripple_count)
-- use this as the third RESOLUTION_TIME_ACTION of the ripple mechanic
	local player = EffectController()
	if player ~= nil and EffectDC() ~= nil and EffectDC():Get_Targets(0) ~= nil then
		for i=0,ripple_count-1 do
			local ripple_spell = EffectDC():Get_Targets(0):Get_CardPtr(i)
			if ripple_spell ~= nil then
				if ripple_spell:CanBePlayed( player ) then
					ripple_spell:PlayFreeFromAnywhere( player )
				end
			end
		end
	end
end

Ripple_ResolutionTimeAction4 = function(ripple_count)
-- use this as the fourth (and last) RESOLUTION_TIME_ACTION of the ripple mechanic
	local player = EffectController()
	if player ~= nil and EffectDC() ~= nil then
		local reveal_chest = EffectDC():Get_Chest(1)
		if reveal_chest ~= nil then
			for i=0,ripple_count-1 do
				local card = reveal_chest:Get_CardPtr(i)
				if card ~= nil and card:GetZone() == ZONE_LIBRARY then
					card:GuidedReveal( ZONE_LIBRARY, ZONE_LIBRARY )
					card:PutInLibrary(-1)
				end
			end
		end
	end
end